<?
class DB
{
	private $Cn = null; //conexao com banco de dados.
	private $DBHOST;
	private $DBUSER;
	private $DBPASSWORD;
	private $DBNAME;
	private $EspecificDBName = null;
	private $EspecificDBConn = null;
	private $connpgvisiodb = null;
	private $statclass = null;
    private function setconnpgvisiodb(){
    	$this->connpgvisiodb = $this->setEspecificDB("pgvisio");
    }
	public function __construct(){
	 	include ("./config/config.inc.php");
		include_once ("./class/statistics.class.php");
	 	$this->DBHOST = $DBHOST;
		$this->DBUSER = $DBUSER;
		$this->DBPASSWORD = $DBPASSWORD;
		$this->DBNAME = $DBNAME;
		$this->Cn = $this->Connect($DBNAME[0],$DBHOST[0],$DBUSER[0],$DBPASSWORD[0]);
		$this->setconnpgvisiodb();
		$this->statclass = new statistics($this->connpgvisiodb);
	}
	public function setEspecificDB($DBNAME){
		try{
		 $this->EspecificDBName = $DBNAME;
		 $this->EspecificDBConn = $this->Connect($DBNAME);
		}
	 	catch(Exception $e){
	 	}
		return $this->EspecificDBConn;
	}
	public function getConn($dbname=''){
		if ($dbname !='') return $this->setEspecificDB($dbname);
		else
			return $this->Cn;
	}
	private function Connect($DBNAME,$DBHOST='',$DBUSER='',$DBPASSWORD=''){
	 	$DBUSER = ($DBUSER=='')?$this->DBUSER[0]:$DBUSER;
	 	$DBPASSWORD = ($DBPASSWORD=='')?$this->DBPASSWORD[0]:$DBPASSWORD;
		$DBHOST     = ($DBHOST=='')     ?$this->DBHOST[0]    :$DBHOST;
			$errmsg = "<div style='background-color:red;margin-top:20%;font-weight:bold;color:#000;font-family:Verdana;' align='center'>" .
					"No  possivel conectar no servidor indicado em /config/config.inc.php.<Br><Br>" .
					"Verifique se o(s) servidores indicados esto em funcionamento e se esto recebendo conexes tcp-ip." .
					"<Br><Br> Veriquei se o(s) usurio(s) e senha(s) para o(s) banco de dado(s) indicados esto configurados no pg_hba.conf";
		try{
			 $retorno = pg_connect("host=$DBHOST user=$DBUSER password=$DBPASSWORD dbname=$DBNAME");
			if(!$retorno)throw new Exception($errmsg);
			}
			catch(Exception $e){
				echo $errmsg;
				if($DBNAME=='')exit;
			}

		return $retorno;
	}
	private function process($query){
	 	// executa a query e retorna o recordset do resultado.
		return pg_query($this->Cn,$query);
	}
	private function return_row($recordset){
		return pg_fetch_array($recordset);
	}
	public function getrelSize($dbname='template0',$pretty=true){
		if ($pretty)
			$sqlstr = "select * from pg_size_pretty(pg_relation_size('$dbname'));";
		else
			$sqlstr = "select * from pg_relation_size('$dbname');";
			$process = $this->process($sqlstr);
	}
	public function getDBSize($dbname='template1', $pretty=true){
		if ($pretty)
			$sqlstr = "select * from pg_size_pretty(pg_database_size('$dbname'));";
		else
			$sqlstr = "select * from pg_database_size('$dbname');";
			$process = $this->return_row($this->process($sqlstr));
			return $process[0];
	}
	public function getDBSizeList(){
	 	$dbs = array();
		$sqlstr = "select oid,datname,pg_database_size(oid)as t, pg_size_pretty(pg_database_size(oid)) as tp from pg_database where datname not in ('template0','template1','postgres') order by t desc;";
			$process = $this->process($sqlstr);
			while ($linhalista = $this->return_row($process))
				$dbs[]= $linhalista;
			return $dbs;
	}
	public function getDBProcess(){
		$process = array();
		$sqlidle = "select count(current_query) from pg_stat_activity where current_query='<IDLE>';";
			$i = $this->process($sqlidle);
			$idle = $this->return_row($i); $idle= $idle[0];
		$sqlstr = "select datname,procpid,usename,query_start,client_addr,current_query from pg_stat_activity order by query_start desc;";
			$p = $this->process($sqlstr);
			while ($linhaprocess = $this->return_row($p)){
				$process[]= $linhaprocess;
			}
			$this->statclass->setNumProccess(pg_num_rows($p),$idle);
			return $process;

	}
	public function StopProcess($PID){
		$sqlstr = "select pg_cancel_backend($PID)";
			$p = $this->process($sqlstr);
			if ($p)
				return true;
			else
				return false;
	}
	public function getDbUserTables($dbname){
		$sqlstr = "select schemaname, relname from pg_stat_user_tables order by schemaname, relname";
		$p = pg_query($this->EspecificDBConn,$sqlstr);
		while ($linhaprocess = $this->return_row($p))
			$process[]= $linhaprocess;
		return $process;
	}
	public function getTablepg_class($dbname,$tblname){
		$sqlstr = "SELECT relname, relkind, reltuples, relpages FROM pg_class WHERE relname LIKE '$tblname%';";
		$c = pg_query($this->EspecificDBConn,$sqlstr);
		while ($linhaclass = $this->return_row($c))
			$process[]= $linhaclass;
		return $process;
	}
	public function getMoreCommonData($tblname){
	$sqlstr = "SELECT s.attname, cast (s.n_distinct as varchar) , s.most_common_vals FROM pg_stats s WHERE tablename = '$tblname';";
		$cd = pg_query($this->EspecificDBConn,$sqlstr);
		while ($linhacommon = $this->return_row($cd))
			$process[]= $linhacommon;
		return $process;
	}
	public function getServerDefinition(){
		$sqlstr = " show all";
		$def = $this->process($sqlstr);
			while ($linhadef = $this->return_row($def))
				$process[]= $linhadef;
			return $process;
	}
	public function getConnectionDef(){
		$sqlstr = "select * from replace(
	(select pg_read_file
			((select current_setting('hba_file')),0,
				(select size from pg_stat_file('pg_hba.conf'))
			))
		,chr(13),'<br>');";
		$def = $this->process($sqlstr);
			while ($linhadef = $this->return_row($def))
				$process[]= $linhadef;
			$process = explode ("<br>",$process[0][0]);
			return $process;

	}
	public function getStatServerDB(){
$sqlstr = "select * from pg_stat_database;";
		$sdb = $this->process($sqlstr);
			while ($lsdb = $this->return_row($sdb))
				$process[]= $lsdb;
			return $process;
	}
	public function getStatSequenceDB($dbname){
		$sqlstr = "select * from pg_statio_user_sequences;";
		$seqs = pg_query($this->EspecificDBConn,$sqlstr);
			while ($rsseqs = $this->return_row($seqs))
				$process[]= $rsseqs;
			return $process;
	}
	public function getAttTable($tblname){
	$sqlstr = "select * from pg_attribute where not attname in ('cmax','xmax','xmin','cmin','ctid','tableoid')
and attrelid=(select relid from pg_stat_user_tables where relname='$tblname') ;";
		$att = pg_query($this->EspecificDBConn,$sqlstr);
			while ($rsatt = $this->return_row($att))
				$process[]= $rsatt;
			return $process;
	}
	public function getUsers(){
		$sqlstr = "select * from pg_shadow;";
		$userrs = $this->process($sqlstr);
			while ($lsdb = $this->return_row($userrs))
				$process[]= $lsdb;
			return $process;
	}
	public function getCompAttTbldata($tblname){
		$sqlstr = "select a.attrelid,a.attname,t.typname,a.attnotnull,a.atthasdef, cast (s.n_distinct as varchar) , s.most_common_vals
		from pg_attribute a
		join pg_type t on (a.atttypid = t.oid)
		left outer join pg_stats s on ( a.attname = s.attname)
		where not a.attname in ('cmax','xmax','xmin','cmin','ctid','tableoid')
		and attrelid=(select relid from pg_stat_user_tables where relname ='$tblname') order by a.attname asc;";
		$att = pg_query($this->EspecificDBConn,$sqlstr);
			while ($rsatt = $this->return_row($att))
				$process[]= $rsatt;
			return $process;
	}

}

?>